﻿package dao

import (
	"code.fnuoos.com/zhimeng/model.git/src/model"
	"xorm.io/xorm"
)

type AgentDao interface {
	GetAgentByUsername(username string) (medium *model.Agent, err error)
	AgentInsert(m *model.Agent) (int64, error)
	AgentDeleteBySession(session *xorm.Session, id interface{}) (int64, error)
	UpdateAgent(m *model.Agent, columns ...string) (int64, error)
	GetAgentRolePermission(id int) (list []*AgentWithRolePermission, total int64, err error)
	FindAdmin(username string, state, page, limit int) (list []model.Agent, total int64, err error)
	GetAgent(id int) (m *model.Agent, err error)
	FindAgentRolePermissionGroup(id int) (list []*AgentWithRolePermissionGroup, total int64, err error)
}

type AgentWithRolePermissionGroup struct {
	model.Agent                    `xorm:"extends"`
	model.AgentWithRole            `xorm:"extends"`
	model.AgentRole                `xorm:"extends"`
	model.AgentRolePermissionGroup `xorm:"extends"`
	model.AgentPermissionGroup     `xorm:"extends"`
}

func (AgentWithRolePermissionGroup) TableName() string {
	return "agent"
}

type AgentWithRolePermission struct {
	model.Agent                          `xorm:"extends"`
	model.AgentWithRole                  `xorm:"extends"`
	model.AgentRole                      `xorm:"extends"`
	model.AgentRolePermissionGroup       `xorm:"extends"`
	model.AgentPermissionGroup           `xorm:"extends"`
	model.AgentPermissionGroupPermission `xorm:"extends"`
	model.AgentPermission                `xorm:"extends"`
}

func (AgentWithRolePermission) TableName() string {
	return "agent"
}
