﻿package dao

import (
	"code.fnuoos.com/zhimeng/model.git/src/model"
	"xorm.io/xorm"
)

type AgentRoleDao interface {
	FindAgentRole() (*[]model.AgentRole, error)
	GetAgentRole(id int) (m *model.AgentRole, err error)
	UpdateAgentRole(m *model.AgentRole, columns ...string) (int64, error)
	AgentRoleDeleteBySession(session *xorm.Session, id interface{}) (int64, error)
	AgentRoleInsert(m *model.AgentRole) (int, error)
	FindPermissionGroupByAgentRole(roleId int) (list []*AgentRolePermissionGroup, total int64, err error)
}

type AgentRolePermissionGroup struct {
	model.AgentRole                `xorm:"extends"`
	model.AgentRolePermissionGroup `xorm:"extends"`
	model.AgentPermissionGroup     `xorm:"extends"`
}

func (AgentRolePermissionGroup) TableName() string {
	return "agent_role"
}
