﻿package implement

import (
	"code.fnuoos.com/zhimeng/model.git/src/dao"
	"code.fnuoos.com/zhimeng/model.git/src/model"
	zhios_order_relate_logx "code.fnuoos.com/zhimeng/model.git/utils/logx"
	"reflect"
	"xorm.io/xorm"
)

func NewAgentWithRoleDb(engine *xorm.Engine) dao.AgentWithRoleDao {
	return &AgentWithRoleDb{Db: engine}
}

type AgentWithRoleDb struct {
	Db *xorm.Engine
}

func (a AgentWithRoleDb) FindAgentWithRole(id int) (*[]model.AgentWithRole, error) {
	var mm []model.AgentWithRole
	if err := a.Db.Where("adm_id =?", id).Find(&mm); err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &mm, nil
}

func (a AgentWithRoleDb) FindAgentWithRoleByRoleId(id int) (*[]model.AgentWithRole, error) {
	var mm []model.AgentWithRole
	if err := a.Db.Where("role_id =?", id).Find(&mm); err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &mm, nil
}

func (a AgentWithRoleDb) AgentDeleteBySessionForAdmId(session *xorm.Session, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return session.In("id", id).Delete(model.AgentWithRole{})
	} else {
		return session.Where("id = ?", id).Delete(model.AgentWithRole{})
	}
}

func (a AgentWithRoleDb) GetAgentWithRoleByRole(id int) (mm *model.AgentWithRole, err error) {
	mm = new(model.AgentWithRole)
	has, err := a.Db.Where("role_id =?", id).Get(mm)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return mm, nil
}

func (a AgentWithRoleDb) AgentWithRoleDeleteForRoleBySession(session *xorm.Session, roleId interface{}) (int64, error) {
	if reflect.TypeOf(roleId).Kind() == reflect.Slice {
		return session.In("role_id", roleId).Delete(model.AgentWithRole{})
	} else {
		return session.Where("role_id = ?", roleId).Delete(model.AgentWithRole{})
	}
}

func (a AgentWithRoleDb) AgentWithRoleDeleteBySession(session *xorm.Session, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return session.In("agent_id", id).Delete(model.AgentWithRole{})
	} else {
		return session.Where("agent_id = ?", id).Delete(model.AgentWithRole{})
	}
}

func (a AgentWithRoleDb) BatchAddAgentWithRoleBySession(session *xorm.Session, mm []*model.AgentWithRole) (int64, error) {
	affected, err := session.Insert(mm)
	if err != nil {
		return 0, err
	}
	return affected, nil
}
