package model

type Agent struct {
	Id                   int    `json:"id" xorm:"not null pk default 0 INT(11)"`
	AgentId              int    `json:"agent_id" xorm:"not null default 0 comment('代理id') INT(11)"`
	Username             string `json:"username" xorm:"not null default '' comment('用户名') VARCHAR(255)"`
	Password             string `json:"password" xorm:"not null default '' comment('密码') VARCHAR(255)"`
	State                int    `json:"state" xorm:"not null default 1 comment('状态(1:正常 2:冻结)') TINYINT(1)"`
	IsSuperAdministrator int    `json:"is_super_administrator" xorm:"not null default 0 comment('是否为超级管理员(0:否 1:是)') TINYINT(1)"`
	Memo                 string `json:"memo" xorm:"not null default '' comment('备注信息') VARCHAR(244)"`
	CreateAt             string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt             string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
