﻿package implement

import (
	"code.fnuoos.com/zhimeng/model.git/src/super/dao"
	"code.fnuoos.com/zhimeng/model.git/src/super/model"
	zhios_order_relate_logx "code.fnuoos.com/zhimeng/model.git/utils/logx"
	"xorm.io/xorm"
)

func NewAgentAppDomainDb(engine *xorm.Engine) dao.AgentAppDomainDao {
	return &AgentAppDomainDb{Db: engine}
}

type AgentAppDomainDb struct {
	Db *xorm.Engine
}

func (a AgentAppDomainDb) GetAgentAppDomainByHost(host string) (m *model.AgentAppDomain, err error) {
	m = new(model.AgentAppDomain)
	has, err := a.Db.Where("domain =?", host).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (a AgentAppDomainDb) GetAgentAppDomain(agent int) (m *model.AgentAppDomain, err error) {
	m = new(model.AgentAppDomain)
	has, err := a.Db.Where("agent_id =?", agent).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (a AgentAppDomainDb) AgentAppDomainInsert(m *model.AgentAppDomain) (int64, error) {
	insertAffected, err := a.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return insertAffected, nil
}
