package implement

import (
	"code.fnuoos.com/zhimeng/model.git/src/super/dao"
	"code.fnuoos.com/zhimeng/model.git/src/super/model"
	zhios_order_relate_logx "code.fnuoos.com/zhimeng/model.git/utils/logx"
	"xorm.io/xorm"
)

func NewAgentListDb(engine *xorm.Engine) dao.AgentListDao {
	return &AgentListDb{Db: engine}
}

type AgentListDb struct {
	Db *xorm.Engine
}

func (a AgentListDb) GetAgentList(agentId int) (medium *model.AgentList, err error) {
	medium = new(model.AgentList)
	has, err := a.Db.Where("agent_id =?", agentId).Get(medium)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return medium, nil
}

func (a AgentListDb) AgentListInsert(m *model.AgentList) (int64, error) {
	insertAffected, err := a.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return insertAffected, nil
}

func (a AgentListDb) UpdateAgentList(m *model.AgentList, columns ...string) (int64, error) {
	affected, err := a.Db.Where("agent_id =?", m.Id).Cols(columns...).Update(m)
	if err != nil {
		return 0, err
	}
	return affected, nil
}
func (a AgentListDb) FindAgentList(name, state string, page, limit int) (list []model.AgentList, total int64, err error) {
	sess := a.Db.Where("state>0").Desc("id").Limit(limit, (page-1)*limit)
	if name != "" {
		sess.And("company_name like ?", "%"+name+"%")
	}
	if state != "" {
		sess.And("state = ?", state)
	}
	total, err = sess.FindAndCount(&list)
	if err != nil {
		return nil, 0, err
	}
	return
}
