package implement

import (
	"code.fnuoos.com/zhimeng/model.git/src/super/dao"
	"code.fnuoos.com/zhimeng/model.git/src/super/model"
	zhios_order_relate_utils "code.fnuoos.com/zhimeng/model.git/utils"
	"xorm.io/xorm"
)

func NewIdcardTypeListDb(engine *xorm.Engine) dao.IdcardTypeListDao {
	return &IdcardTypeListDb{Db: engine}
}

type IdcardTypeListDb struct {
	Db *xorm.Engine
}

func (i IdcardTypeListDb) FindAll() (list []map[string]interface{}) {
	var data []model.IdcardTypeList
	i.Db.Find(&data)
	list = make([]map[string]interface{}, 0)
	top := make([]map[string]interface{}, 0)
	first := make(map[int][]map[string]interface{})
	for _, v := range data {
		tmp := map[string]interface{}{
			"id":    zhios_order_relate_utils.IntToStr(v.Id),
			"name":  v.Name,
			"child": make([]map[string]interface{}, 0),
		}
		if v.Level == 0 {
			top = append(top, tmp)
		}
		if v.Level == 1 {
			_, ok := first[v.Pid]
			if ok == false {
				first[v.Pid] = make([]map[string]interface{}, 0)
			}
			first[v.Pid] = append(first[v.Pid], tmp)
		}
	}
	for k, v := range top {
		id := zhios_order_relate_utils.StrToInt(zhios_order_relate_utils.AnyToString(v["id"]))
		top[k]["child"] = first[id]
	}
	if len(top) > 0 {
		list = top
	}
	return
}
